
/* state is where the parser currently is in the file */
enum states { OUT,
              READ_SCHEME, READ_SCHEME_NAME, IN_SCHEME,
              READ_IFACE, READ_IFACE_NAME, IN_IFACE,
              READ_INET, READ_INET_NAME, IN_INET,
              READ_INET_OPTION_NAME, READ_INET_OPTION_VAL,

              /* 12 */
              READ_DEMAND, IN_DEMAND,
              READ_PROVIDER, READ_PROVIDER_NAME, IN_PROVIDER,
              READ_PROVIDER_OPTION_NAME, READ_PROVIDER_OPTION_VAL };

int lineno;

typedef struct t_opt t_opt;
typedef struct t_scheme t_scheme;
typedef struct t_iface t_iface;
typedef struct t_alias t_alias;
typedef struct t_provider t_provider;
typedef struct t_netconf t_netconf;

struct t_opt {
	char *name;
	char *val;

	t_opt *next;
};

struct t_netconf {
	t_provider *demand;
	t_scheme *schemes;
};


struct t_scheme {
	char *name;

	t_opt *options;
	t_scheme *next;
	t_iface *iface;
};

struct t_provider {
	char *name;
	t_opt *options;

	t_provider *next;
};

struct t_iface {
	char *name;

	t_opt *options;
	t_iface *next;
	t_alias *alias;
};

struct t_alias {
	t_opt *options;
	t_alias *next;
};

char *errstr;

/* functions */
t_netconf *parse_file (const char *filename);

t_scheme *scheme_add (t_scheme *scheme);
t_iface *iface_add (t_iface *iface);
t_alias *alias_add (t_alias *alias);
t_provider *provider_add (t_provider *provider);


void err (char *str);
void warn (char *str);

char *getopt (t_opt *opt, char *name);
void setopt (t_opt **opt, char *name, char *val);

