#include "str.h"

#include <stdio.h>


/*
 * strsegcpy() copies src to desc until reaching a \0 or c
 * returns: pointer to char right after c
 * */

char*
strsegcpy (char *dest, const char *src, char c)
{
	if (src == NULL) return NULL;
	while (*src != c && *src != 0)
		*dest++ = *src++;

	*dest = 0;
	if (*src == c) {
		return (char*) src+1;
	}
	return NULL;
	
}

/*
 * strsegcmp() looks for s2 followed by c in s1,
 * returns: pointer to char right after c or NULL
 * */

char*
strsegcmp (const char *s1, const char *s2, char c)
{
	while (*s1++ == *s2 && *s1 != 0 && *s1 != c)
		s2++;

	if (*s1 == c)
		return (char*) s1+1;
	return NULL;
	
}



void
chop (char *str, char c)
{
	while (*str != 0)
		str++;
	if (*str == 0) {
		if (*(str-1) == c)
			*(str-1) = 0;
	}
}

